/* 
 * $Id: GLSDImportModuleAdapter.h,v 1.6 2006/07/13 13:31:18 ozawa Exp $
 *
 * Copyright 2005- ONGS Inc. All rights reserved.
 * 
 * author: Masanori OZAWA (ozawa@ongs.co.jp)
 * version: $Revision: 1.6 $
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY ONGS INC ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL ONGS INC OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the ONGS Inc.
 * 
 */

#ifndef ___GLSDIMPORTMODULEADAPTER_H
#define ___GLSDIMPORTMODULEADAPTER_H

#include "modules/imports/GLSDImportModule.h"

namespace XDTP {

typedef enum {
    TIP_SUCCESS = 0,
    TIP_FAILED = 1,
    TIP_SKIP = 2
} TIP_STATUS;

class GLSDImportModuleAdapter : public GLSDImportModule
{
public:
	GLSDImportModuleAdapter();
	virtual ~GLSDImportModuleAdapter();

    /**
     * 򳫻Ϥ˽Ϸꤷޤ
     * 
     * @param aType Ϸ
     */
    virtual void setOutputType(const Glib::ustring& aType);
    
    /**
     * 򳫻Ϥ˥ץꤷޤ
     * 
     * @param anOptions ץ
     */
    virtual void setOption(const StringList& anOptions);

    /**
     * 򳫻Ϥ˽ϥե̾ꤷޤ
     * 
     * @param anOutputFile ϥե̾
     */
    virtual void setOutputFile(const Glib::ustring& anOutputFile);

    /**
     * 򳫻ϤѴXMLե̾ꤷޤ
     * 
     * @param aXMLFile ѴXMLե̾
     */
    virtual void setXMLFile(const Glib::ustring& aXMLFile);
    
    /**
     * ϥեΥ󥳡ɤꤷޤ
     * XMLեϤθ¤ǤϤޤ
     * 
     * @param anInputEncoding ϥեΥ󥳡
     */
    virtual void setInputEncoding(const Glib::ustring& anInputEncoding);

    /**
     * ϥեΥ󥳡ɤꤷޤ
     * 
     * @param anOutputEncoding ϥեΥ󥳡
     */
    virtual void setOutputEncoding(const Glib::ustring& anOutputEncoding);

    /**
     * ߤXDTPTransform⥸塼ꤷޤ
     * 
     * @param aXDTPTransform ߤXDTPTransform⥸塼
     */
    virtual void setXDTPTransform(const XDTPTransform *aXDTPTransform);

    /**
     * XMLեΥ󥳡ǥ󥰤ꤷޤ
     * 
     * @param anEncoding XMLեΥ󥳡ǥ
     */
    virtual void setXMLEncoding(const std::string& anEncoding);

    /**
     * եparseľ˸ƤӽФޤ
     * 
     * @param aFile parseоݤΥե̾
     */
    virtual void treatPreFile(const Glib::ustring& aFile);

    /**
     * parseXMLʸϤXSLѴľ˸ƤӽФޤ
     * 
     * @param aDocument XMLʸ
     */
    virtual void treatPreDocument(xmlDocPtr aDocument);

    /**
     * XSLѴXMLʸϤ¸ľ˸ƤӽФޤ
     * 
     * @param aDocument XMLʸ
     */
    virtual void treatPostDocument(xmlDocPtr aDocument);

    /**
     * XMLʸϤ¸ľ˸ƤӽФޤ
     * 
     * @param aFile ¸ե̾
     */
    virtual void treatPostFile(const Glib::ustring& aFile);
    
protected:
    /**
     * ߤXDTPTransform⥸塼ޤ
     * 
     * @return ߤXDTPTransform⥸塼
     */
    virtual const XDTPTransform * getXDTPTransform();

protected:
    /**
     * ե뤫饤ݡȽоݤʬФִ
     * Ԥݤ˸ƤӽФޤ
     * 
     * @param aRef ݡΥե
     * @param aCaption ץ
     * @param anEncoding ݡΥեΥ󥳡
     * @param aNewData ִ٤ʸޤ
     * @return ̤ޤ
     */
    virtual TIP_STATUS transformImportPointCallback
        (const Glib::ustring& aRef, const Glib::ustring& aCaption,
         const Glib::ustring& anEncoding, Glib::ustring& aNewData);

    /**
     * ݡȽоݤ̤Ρɤۤޤ
     * 
     * @param aType оݤμ
     * @param aRef ݡΥե
     * @param aCaption ץ
     * @param anEncoding ݡΥեΥ󥳡
     * @return ݡȽоݤ̤Ρ
     */
    xmlNodePtr createNewImportPointNode
         (const Glib::ustring& aType, const Glib::ustring& aRef,
          const Glib::ustring& aCaption, const Glib::ustring& anEncoding);
    
    /**
     * ե뤫饤ݡȽоݤʬФִԤޤ
     * 
     * @param aFile оݤΥե
     * @param aType оݤμ
     * @return  true ᤷޤ
     */
    bool transformImportPoint
        (const Glib::ustring& aFile, const Glib::ustring& aType);

protected:
    /**
     * URIǻȤ꥽ؤIOChannelޤ
     * Ǥʤ XDTP::Exception  throw ޤ
     * 
     * @param aRef URI
     * @param aTmpFile եϡեؤΥѥޤ
     *                 ʤϡʸޤ
     * @return ꥽ؤIOChannel
     */
    Glib::RefPtr<Glib::IOChannel> getIOChannel
        (const Glib::ustring& aRef, std::string& aTmpFile);

    /**
     * ե򻲾ȤURLХѥѴޤ
     * 
     * @param url ꥽ؤURL
     * @return URL
     */
    Glib::ustring normalizeURL(const Glib::ustring& url);
    
    /**
     * եɤ߹ѥ󥳡ɤŬڤꤹ롣
     * 
     * @param anIOC 󥳡ɤꤹIOChannel
     * @param anEncoding ͥŪꤹ륨󥳡ɡʾ϶ʸꤹ롣
     */
    void setEncoding(Glib::RefPtr<Glib::IOChannel>& anIOC,
                     const Glib::ustring& anEncoding);

    /**
     * ΥǼ̤륪ץͤޤ
     * 
     * @param aKey ץդ˼̤
     * @param aValue ץͤǼΰ
     * @return ץ󤬸դǤ true ᤷޤ
     */
    bool getOptionInt(const Glib::ustring& aKey, int &aValue);
    bool getOptionString(const Glib::ustring& aKey, Glib::ustring& aValue);

protected:
    /**
     * ǤեפΥ륷Ȥ롣
     * 
     * @param aDocument
     *            XHTMLɥ
     * @param aType
     *            륷ȤΥ
     *            ˾ʸǻꤹɬפޤ
     * @return  륷
     */
    static xmlNodePtr getStyleSheet(xmlDocPtr aDocument, const Glib::ustring& aType);

    /**
     * ImportγƼ°ͤޤ
     * 
     * @param aNode ImportΡ
     * @param aRef ꥽URL
     * @param aCaption ץ
     * @param anEncoding ꥽Υ󥳡ǥ
     * @return  true ᤹
     */
    static bool getImportAttributes(xmlNodePtr aNode, Glib::ustring& aRef,
                                    Glib::ustring& aCaption, Glib::ustring& anEncoding);

    /**
     * XMLɥѤüʸ򥨥פޤ
     * 
     * @param aString üʸޤʸ
     * @return ׸ʸ
     */
    static Glib::ustring escapeString(const Glib::ustring& aString);

    /**
     * Importƥȷݻޤ
     */
    static bool preserveImport(xmlDocPtr aDocument, xmlNodePtr aNode,
                               const Glib::ustring& aRef,
                               const Glib::ustring& aCaption,
                               const Glib::ustring& anEncoding);

protected:
    StringList      m_OptionList;
    Glib::ustring   m_OutputType;
    Glib::ustring   m_InputEncoding;
    Glib::ustring   m_OutputEncoding;
    Glib::ustring   m_XMLFile;
    Glib::ustring   m_OutputFile;
    std::string     m_XMLEncoding;

private:
    const XDTPTransform     *m_pXDTPTransform;
};

};

#endif
