/* 
 * $Id: xdtptypes.h,v 1.9 2006/06/30 05:09:11 ozawa Exp $
 *
 * Copyright 2005- ONGS Inc. All rights reserved.
 * 
 * author: Masanori OZAWA (ozawa@ongs.co.jp)
 * version: $Revision: 1.9 $
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY ONGS INC ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL ONGS INC OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the ONGS Inc.
 * 
 */

#ifndef ___XDTPTYPES_H
#define ___XDTPTYPES_H

#include "glibmm.h"
#include "Exception.h"

#include <sys/types.h>
#include <list>
#include <map>
#include <string>

#define DEFAULT_OUTPUT_TYPE     "html"
#define DEFAULT_OUTPUT_ENCODING "utf-8"

#define XDTP_MODULE_VERSION     0x00010001

#define OUTPUT_FILE_MASK_KEY	"OUTPUT_FILE_MASK"

#ifdef WIN32
# define    FILE_SEP    "\\"
# define    LINE_SEP    "\r\n"
#else
# define    FILE_SEP    "/"
# define    LINE_SEP    "\n"
#endif

namespace XDTP {
typedef std::list<Glib::ustring>    StringList;
typedef std::list<StringList>       StringTable;
typedef std::vector<int>            IntVector;
typedef std::vector<void*>          PointerVector;
typedef std::map<int, void*>        Int2PointerMap;
typedef std::map<Glib::ustring, Glib::ustring>  String2StringMap;
};

#endif
